print "TMLevelMeter.pl ver.1.01 beta\n";
print "Copyright (c)2007 ◆tamacs7CR., All Rights Reserved.\n";


use Getopt::Long;
use Lingua::JA::Romanize::Kana;
$conv = Lingua::JA::Romanize::Kana->new(); 
$ratio="0.9";
GetOptions ('input=s' => \$inputfile, 'output=s' => \$outputfile, 'debug' => \$mydebug, 'lane' => \$mylane, 'ratio=f' => \$ratio, 'msdos' => \$msdos) || die "オプション取得エラー :$!\n";
$mypercent=$ratio*100;
if($inputfile){
    if($mydebug){
        print "$inputfileの読み込みを開始します\n";
    }
    open ( FILEHANDLE , "< $inputfile" ) || die "ファイルを開けませんでした :$!\n";
        if(!$msdos){
            if($mydebug){
                print "ファイルをロックします\n";
            }
            flock(FILEHANDLE, 1);
        }
        @mylist = <FILEHANDLE>;
    close(FILEHANDLE);
    if($mydebug){
        print "$inputfileの読み込みを終了しました\n";
    }
}else{
    print "エラー:読み込みファイル名が指定されていません\n";
    exit;
}

if($mydebug){
    print "記号の置き換えを開始します\n";
}

for($i=0; $i<=$#mylist; $i++){
    $mylist[$i]=~s/\r//;
    $mylist[$i]=~s/\n//;
    $mylist[$i]=~s/ー/-/;
    $mylist[$i]=~s/＆/&/;
    $mylist[$i]=~s/　/ /;
    $mylist[$i]=~s/？/?/;
    $mylist[$i]=~s/！/!/;
    if($mydebug){
        print "改行コードを削除しました:$mylist[$i]\n";
    }
    
}

if($mydebug){
    print "データの解析を開始します\n";
}

foreach $mydata (@mylist ) {
    if($mydata=~/<word>/ && $mydata=~/<\/word>/){
        if($mydebug){
            print "よみがな:$mydata\n";
        }
        @mytemp=split(/<word>/,$mydata);
        @mytemp=split(/<\/word>/,$mytemp[1]);
        push(@kana,$mytemp[0]);
        if($mydebug){
            print "よみがな$#kana行目抜き出し完了:$kana[$#kana]\n";
        }
    }elsif($mydata=~/<interval>/ && $mydata=~/<\/interval>/){
        if($mydebug){
            print "Interval:$mydata\n";
        }
        @mytemp=split(/<interval>/,$mydata);
        @mytemp=split(/<\/interval>/,$mytemp[1]);
        push(@interval,$mytemp[0]);
        if($mydebug){
            print "Interval$#interval行目抜き出し完了:$interval[$#interval]\n";
        }
    }else{
        if($mydebug){
            print "解析対象外:$mydata\n";
        }
    }
}

if($mydebug){
    print "かな→ローマ字変換を開始します\n";
}


foreach $mydata (@kana) {
    if($mydebug){
        print "ローマ字変換:$mydata\n";
    }
push(@roman,$conv->chars( $mydata ));
    if($mydebug){
        print "変換結果:$roman[$#roman]\n";
    }
}

if($mydebug){
    print "各行のデータ解析を開始します。\n";
}

for($i=0; $i<=$#interval; $i++){
    if($mydebug){
        print "間奏かどうかの判断を行います:$roman[$i]\n";
    }
    if($roman[$i] ne "@"){
        if($mydebug){
            print "間奏でないと判断されました。文字数を取得します。:$roman[$i]\n";
        }
        @mylength[$i]=length($roman[$i]);
        if($mydebug){
            print "文字数$mylength[$i]文字:$roman[$i]\n";
        }
        if($mydebug){
            print "インターバルを分単位に変換します:$interval[$i]\n";
        }
        @minterval[$i]=$interval[$i]/60000;
        if($mydebug){
            print "$minterval[$i]分間:$roman[$i]\n";
        }
        @fullanswer[$i]=$mylength[$i]/$minterval[$i];
        if($mydebug){
            print "満点必要速度$fullanswer[$i]キー/分:$roman[$i]\n";
        }
        @myanswer[$i]=($mylength[$i] * $ratio)/$minterval[$i];
        if($mydebug){
            print "$mypercent%クリア必要速度$myanswer[$i]キー/分:$roman[$i]\n";
        }
    
    }else{
        if($mydebug){
            print "間奏と判断されました:$roman[$i]\n";
        }
    }
}

if($mydebug){
    print "最大速度と平均速度の計算を開始します\n";
}

if($mydebug){
    print "最大速度を初期化します\n";
}

$fullhispeed=0;
$myhispeed=0;

if($mydebug){
    print "最大速度の初期化が完了しました\n";
}

for($i=0; $i<=$#interval; $i++){
    if($mydebug || $mylane){
            $myresult.="$kana[$i]\n";
                if($mydebug){
                    $myresult.="文字数:$mylength[$i]　インターバル:$interval[$i]　";
                }
            $myresult.="満点必要速度:$fullanswer[$i]キー/分　$mypercent%クリア必要速度:$myanswer[$i]キー/分\n";

    }
    if($fullhispeed<$fullanswer[$i]){
        if($mydebug){
            print "最大速度$i行目:満点必要速度$fullanswer[$i]キー/min\n";
        }
        $fullhispeed=$fullanswer[$i];
    }
    if($myhispeed<$myanswer[$i]){
        if($mydebug){
            print "最大速度$i行目:$mypercent%クリア必要速度$fullanswer[$i]キー/min\n";
        }
        $myhispeed=$myanswer[$i];
    }
}

if($mydebug){
    print "満点必要平均速度を取得します\n";
}

foreach $a(@fullanswer){
    $fullaverage+=$a;
    if($mydebug){
        print "fullaverage=$fullaverage\n";
    }
}

$fullaverage/=$#interval;

if($mydebug){
    print "$mypercent%クリア必要平均速度を取得します\n";
}
foreach $a(@myanswer){
    $myaverage+=$a;
    if($mydebug){
        print "myaverage=$myaverage\n";
    }
}

$myaverage/=$#interval;

if($mydebug){
    print "レベルを求めます\n";
}

$mylevel=($myaverage+50)/50;

if($mydebug){
    print "最終結果をまとめます\n";
}

$myresult .=<< "_END_";
===$inputfile===
行数:$#interval行
200000点に必要な最大速度:$fullhispeedキー/min
200000点に必要な平均速度:$fullaverageキー/min
$mypercent%クリアに必要な最大速度:$myhispeedキー/min
$mypercent%クリアに必要な平均速度:$myaverageキー/min
Level:$mylevel
_END_
if($mydebug){
    print "最終結果を表示します\n";
}
print $myresult;

if($outputfile){
    if($mydebug){
        print "結果のファイル出力を開始します\n";
    }
    open ( FILEHANDLE , ">> $outputfile" ) ;
    if(!$msdos){
        if($mydebug){
            print "ファイルをロックします\n";
        }
        flock(FILEHANDLE, 6);
    }
    print FILEHANDLE $myresult;
    close(FILEHANDLE);
    if($mydebug){
        print "結果のファイル出力を終了します\n";
    }
}

if($mydebug){
    print "処理完了\n";
}
exit;